/**
******************************************************************************
* @file         httputil.c
* @version      V1.0
* @date         2020-06-05
* @brief        httpЭ飬ȹ
*
* @company      Ƽ޹˾
* @information  WIZnet W5500ٷ̣ȫ̼֧֣۸ƴ
* @website      www.wisioe.com
* @forum        www.w5500.cn
* @qqGroup      579842114
* @Support      QQ:2571856470Mob:18998931307
* @Email        support@wisioe.com
******************************************************************************
*/
#include "httputil.h"
#include "webpge.h"
#include "utility.h"
#include "bsp_usart1.h"
#define DEBUG_HTTP

uint8 reboot_flag = 0;
uint8 boundary[64];
uint8 tmp_buf[1460]={0xff,};

/**
*@brief  Ϣõjson_callback
*@param  
*@return 
*/
static void make_basic_config_setting_json_callback(int8* buf, CONFIG_MSG config_msg)
{
  sprintf(buf,"settingsCallback({\"ver\":\"%d.%d\",\
                \"mac\":\"%02X:%02X:%02X:%02X:%02X:%02X\",\
                \"ip\":\"%d.%d.%d.%d\",\
                \"gw\":\"%d.%d.%d.%d\",\
                \"sub\":\"%d.%d.%d.%d\",\
                });",config_msg.sw_ver[0],config_msg.sw_ver[1],
                config_msg.mac[0],config_msg.mac[1],config_msg.mac[2],config_msg.mac[3],config_msg.mac[4],config_msg.mac[5],
                config_msg.lip[0],config_msg.lip[1],config_msg.lip[2],config_msg.lip[3],
                config_msg.gw[0],config_msg.gw[1],config_msg.gw[2],config_msg.gw[3],
                config_msg.sub[0],config_msg.sub[1],config_msg.sub[2],config_msg.sub[3]
                );
}

/**
*@brief  httpӦ
*@param  
*@return 
*/
void do_https(void)
{
  uint8 ch=SOCK_HTTPS;                                    /*һsocket*/
  uint16 len;
  
  st_http_request *http_request;                          /*һṹָ*/
  memset(rx_buf,0x00,MAX_URI_SIZE);
  http_request = (st_http_request*)rx_buf;           
  /* http service start */
  switch(getSn_SR(ch))                                    /*ȡsocket״̬*/
  {
    case SOCK_INIT:                                       /*socketڳʼ״̬*/
      listen(ch);
      break;
    
    case SOCK_LISTEN:                                     /*socketڼ״̬*/
      break;
    
    case SOCK_ESTABLISHED:                                /*socket״̬*/
      if(getSn_IR(ch) & Sn_IR_CON)
      {
        setSn_IR(ch, Sn_IR_CON);                          /*жϱ־λ*/
      }
      if ((len = getSn_RX_RSR(ch)) > 0)    
      {
        len = recv(ch, (uint8*)http_request, len);        /*http*/
        *(((uint8*)http_request)+len) = 0;
        proc_http(ch, (uint8*)http_request);              /*http󲢷httpӦ*/
        disconnect(ch);
      }
      break;
      
    case SOCK_CLOSE_WAIT:                                 /*socketڵȴر״̬*/
      if ((len = getSn_RX_RSR(ch)) > 0)
      {
        len = recv(ch, (uint8*)http_request, len);        /*http*/      
        *(((uint8*)http_request)+len) = 0;
        proc_http(ch, (uint8*)http_request);              /*http󲢷httpӦ*/
      }
      disconnect(ch);
      break;
      
    case SOCK_CLOSED:                                     /*socketڹر״̬*/
      socket(ch, Sn_MR_TCP, 80, 0x00);                     /*socket*/
      break;
    
    default:
      break;
  }
}

/**
*@brief  httpĲhttpӦ
*@param  s: httpsocket
*@param  buf
*@return 
*/
void proc_http(SOCKET s, uint8 * buf)
{
  int8* name;                       
  int8 req_name[32]={0x00,};                              /*һhttpӦĵָ*/
  unsigned long file_len=0;                               /*httpͷĽṹָ*/
  uint16 send_len=0;
  uint8* http_response;
  st_http_request *http_request;
  memset(tx_buf,0x00,MAX_URI_SIZE);
  http_response = (uint8*)rx_buf;
  http_request = (st_http_request*)tx_buf;
  parse_http_request(http_request, buf);                  /*httpͷ*/

  switch (http_request->METHOD)    
  {
    case METHOD_ERR :                                      /*ͷ*/
      memcpy(http_response, ERROR_REQUEST_PAGE, sizeof(ERROR_REQUEST_PAGE));
      send(s, (uint8 *)http_response, strlen((int8 const*)http_response));
      break;
    
    case METHOD_HEAD:                                      /*HEADʽ*/
      
    case METHOD_GET:                                       /*GETʽ*/
      name = http_request->URI;
      if(strcmp(name,"/index.htm")==0 || strcmp(name,"/")==0 || (strcmp(name,"/index.html")==0))
      {
        file_len = strlen((const char *)INDEX_HTML);
        make_http_response_head((uint8*)http_response, PTYPE_HTML,file_len);
        send(s,http_response,strlen((char const*)http_response));
        send_len=0;
        while(file_len)
        {
          if(file_len>1024)
          {
            if(getSn_SR(s)!=SOCK_ESTABLISHED)
            {
              return;
            }
            send(s, (uint8 *)INDEX_HTML+send_len, 1024);
            send_len+=1024;
            file_len-=1024;
          }
          else
          {
            send(s, (uint8 *)INDEX_HTML+send_len, file_len);
            send_len+=file_len;
            file_len-=file_len;
          }
          delay_us(74);
        }
      }
      else if(strcmp(name,"/w5500.js")==0)
      {
        memset(tx_buf,0,MAX_URI_SIZE);
        make_basic_config_setting_json_callback(tx_buf,ConfigMsg);
        sprintf((char *)http_response,"HTTP/1.1 200 OK\r\nContent-Type: text/html\r\nContent-Length:%d\r\n\r\n%s",strlen(tx_buf),tx_buf);
        send(s, (u_char *)http_response, strlen((char const*)http_response));
      }
      break;
      
    case METHOD_POST:                                      /*POST*/
      mid(http_request->URI, "/", " ", req_name);          /*ȡļ*/
      if(strcmp(req_name,"config.cgi")==0)                  
      {
//        cgi_ipconfig(http_request);                      /*ϢдƬeeprom*/
        make_cgi_response(5,(int8*)ConfigMsg.lip,tx_buf);  /*Ӧı*/        
        sprintf((char *)http_response,"HTTP/1.1 200 OK\r\nContent-Type: text/html\r\nContent-Length:%d\r\n\r\n%s",strlen(tx_buf),tx_buf);
                                                           /*httpӦ*/
        send(s, (u_char *)http_response, strlen((char *)http_response));    
        disconnect(s);                                     /*Ͽsocket*/        
        reboot_flag=1;                                     /*־λ1*/
        return;
      }
      break;
      
    default :
      break;
  }
}

///**
//*@brief    ϢдƬeeprom
//*@param    http_requestһhttpĽṹָ
//*@return  
//*/
//void cgi_ipconfig(st_http_request *http_request)
//{ 
//  uint8 * param;
//  param = get_http_param_value(http_request->URI,"ip");    /*ȡ޸ĺIPַ*/
//  //printf("  ޸ĺ ip ַ %s \r\n",param);
//  if(param)
//  {
//    inet_addr_((uint8*)param, ConfigMsg.lip);  
//  }
//  param = get_http_param_value(http_request->URI,"gw");    /*ȡ޸ĺ*/
//  if(param)
//  {
//    inet_addr_((uint8*)param, ConfigMsg.gw);  
//  }
//  param = get_http_param_value(http_request->URI,"sub");   /*ȡ޸ĺ*/
//  if(param)
//  {
//    inet_addr_((uint8*)param, ConfigMsg.sub);    
//  }
//  write_config_to_eeprom();                                /*ȡдeeprom*/
//}

/**
*@brief  ִhttpӦ
*@param    
*@return 
*/
void make_cgi_response(uint16 delay, int8* url,int8* cgi_response_buf)
{
  sprintf(cgi_response_buf,"<html><head><title>iWeb - Configuration</title><script language=javascript>j=%d;function func(){document.getElementById('delay').innerText=' '+j + ' ';j--;setTimeout('func()',1000);if(j==0)location.href='http://%d.%d.%d.%d/';}</script></head><body onload='func()'>please wait for a while, the module will boot in<span style='color:red;' id='delay'></span> seconds.</body></html>",delay,url[0],url[1],url[2],url[3]);
  return;
}


